Attribute VB_Name = "MUnit"
Option Explicit
Option Base 1

Dim predUnitName() As String
Dim staffSheets As New Collection
Dim curLevel As Long

Private Function GetLevel(value As Range, Error As Boolean) As Long
Static predLevel As Long

    Error = False
    Select Case value.Interior.ColorIndex
    Case HLevel1
       GetLevel = 1
    Case HLevel2
       GetLevel = 2
    Case HLevel3
       GetLevel = 3
    Case Else
       GetLevel = IIf(predLevel = 0, 1, predLevel)
       Error = True
    End Select
    
    predLevel = GetLevel
    
End Function


Private Function IsUnit(value As Range) As Boolean
    IsUnit = CStr(value) <> vbNullString And _
        Not (IsNull(Range(value.Offset(0, 2), value.Offset(0, 14)).Text))
End Function

Private Function IsFormatMini(value As Range) As Boolean
    IsFormatMini = CStr(value) Like strOfficePattern
End Function

Private Sub SetDimension(value As Variant, UpBound As Long)
  If UpBound > UBound(value) Then _
     ReDim Preserve value(UBound(value) + 1)
End Sub

Private Sub Init()
    ReDim predUnitName(1)
    curLevel = 1
End Sub


Private Function IsFilial(value As Range) As Boolean
    IsFilial = CStr(value) Like strFullBankName
End Function

Private Sub CreateStaffSheets(wb As Workbook)
Dim stSheet As Worksheet

   For Each stSheet In wb.Worksheets
    If stSheet.Cells(rowStrStaffShedule, columnStrStaffShedule) = strStaffShedule Then
      If IsFilial(stSheet.Cells(rowUnitName, columnUnitName)) Then
        staffSheets.Add Item:=stSheet, Before:=1
     Else: staffSheets.Add stSheet
      End If
    End If
   Next stSheet
   
End Sub

Private Function GetLastRow(ws As Worksheet) As Long
   GetLastRow = ws.Cells(Rows.Count, columnUnitName).End(xlUp).Row
End Function


Public Sub BuildTree()
 
Dim curRow As Long
Dim File As Long
Dim curSheet As Long
Dim errLevel As Boolean
Dim activWB As New Workbook
Dim stSheet As New Worksheet
Dim FilesToOpen
Dim strFilialName As String

'On Error GoTo ErrHandler
Application.ScreenUpdating = False

'FilesToOpen = Application.GetOpenFilename _
      (FileFilter:=strFileOpenFilter, MultiSelect:=True, Title:=strFileOpenTitle)
      
'If TypeName(FilesToOpen) = "Boolean" Then GoTo ExitHandler
 
'For File = LBound(FilesToOpen) To UBound(FilesToOpen)

 '   Application.Workbooks.Open Filename:=FilesToOpen(File), UpdateLinks:=0
    Set activWB = ActiveWorkbook
    
    Call CreateStaffSheets(activWB)
      
    For curSheet = 1 To staffSheets.Count
    
        Set stSheet = staffSheets.Item(curSheet)
        
        Call Init
        
        predUnitName(curLevel) = stSheet.Cells(rowUnitName, columnUnitName)
        
        If curSheet = 1 Then
            strFilialName = predUnitName(curLevel)
            Filial.Units.Add predUnitName(curLevel), CreateUnit(predUnitName(curLevel), curLevel, errLevel)
        Else
            Set Unit = Filial.FindEx(strFilialName, curLevel)
        End If

        For curRow = firstRowUnit To GetLastRow(stSheet)
           If IsUnit(stSheet.Cells(curRow, columnUnitName)) Then
           
               If IsFormatMini(stSheet.Cells(curRow, columnUnitName)) Then Exit For
               
               curLevel = GetLevel(stSheet.Cells(curRow, columnUnitName), errLevel) + 1
               Call SetDimension(predUnitName, curLevel)
               predUnitName(curLevel) = stSheet.Cells(curRow, columnUnitName)
               Set Unit = Filial.FindEx(predUnitName(curLevel - 1), curLevel - 1)
               Unit.Units.Add (predUnitName(curLevel)), CreateUnit(predUnitName(curLevel), curLevel, errLevel)
               
'               curLevel = GetLevel(stSheet.Cells(curRow, columnUnitName), errLevel) + 1
'               Call SetDimension(predUnitName, curLevel)
'               predUnitName(curLevel) = stSheet.Cells(curRow, columnUnitName)
'               Set Unit = Filial.FindEx(predUnitName(curLevel - 1), curLevel - 1)
'               Unit.Units.Add CreateUnit(predUnitName(curLevel), curLevel, errLevel)
'
               
               
               
               
           End If
        Next curRow
        
    Next curSheet
    

  '  activWB.Close SaveChanges:=False
    
    Set activWB = Nothing
    Set Unit = Nothing
    Set stSheet = Nothing
    Set staffSheets = Nothing
    
'Next File


ExitHandler:
    Application.ScreenUpdating = True
    Exit Sub

ErrHandler:

    Set activWB = Nothing
    Set Unit = Nothing
    Set stSheet = Nothing
    Set staffSheets = Nothing
    
    Resume ExitHandler
 
End Sub

Private Function CreateUnit(Name As String, Level As Long, Optional Mach As Boolean, Optional CCode As String, _
                 Optional UID As Long, Optional ParentID) As CSubdivision
                
 Dim Unit As New CSubdivision

 Set CreateUnit = Nothing
 
 If (Name <> vbNullString) And (Level > 0) Then
    Unit.Name = CStr(Name)
    Unit.Level = CLng(Level)
    If IsMissing(CCode) Then Unit.CCode = CCode
    Unit.UID = IIf(IsMissing(UID), 0, CLng(UID))
    Unit.ParentID = IIf(IsMissing(ParentID), 0, CLng(ParentID))
    Unit.Mach = IIf(IsMissing(Mach), False, CBool(Mach))
    Set CreateUnit = Unit
 End If

End Function



